import {
	Controller,
	DefaultValuePipe,
	Delete,
	Get,
	Param,
	ParseIntPipe,
	Post,
	Query,
	UseGuards,
} from "@nestjs/common";
import { AdminGuard } from "apps/backend/src/app/auth/auth.guard";
import { AuthorsService } from "apps/backend/src/app/authors/authors.service";

@Controller("authors")
export class AuthorsController {
	constructor(private readonly authorService: AuthorsService) {}

	@Get("find")
	async findMany(
		@Query("limit", new DefaultValuePipe(20), ParseIntPipe) limit: number,
		@Query("offset", new DefaultValuePipe(0), ParseIntPipe) offset: number,
		@Query("search", new DefaultValuePipe("")) search: string,
	) {}

	//TODO DTO
	@Post("new")
	async newAuthor() {}

	@UseGuards(AdminGuard)
	@Delete(":autor")
	async deleteAuthor(@Param("author") author: string) {}

	//TODO Patch

	@Get("files/:author")
	async getFilesForAuthor(
		@Query("limit", new DefaultValuePipe(20), ParseIntPipe) limit: number,
		@Query("offset", new DefaultValuePipe(0), ParseIntPipe) offset: number,
		@Query("search", new DefaultValuePipe("")) search: string,
		@Param("machineId") author: string,
	) {}
}
